<?php

namespace FiloBlu\Orderstatus\Plugin\Sales\Model;

class Order
{
    const DEBUG_LOG_ACTIVE = TRUE;

    public function beforeAddStatusHistory(
        \Magento\Sales\Model\Order $subject,
        $history
    ) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $helper = $objectManager->create('FiloBlu\OrderStatus\Helper\Data');
        $logger = $objectManager->create('Psr\Log\LoggerInterface');

        $fromStatus = $subject->getOrigData('status');
        $toStatus = $subject->getData('status');
        $hasInvoice = $subject->hasInvoices();

        if(!$helper->isValidStatusUpdate($fromStatus, $toStatus, $hasInvoice))
        {
            if (self::DEBUG_LOG_ACTIVE)
            {
                $logger->addInfo("FiloBlu\Orderstatus\Plugin\Sales\Model: Status cannot be updated in payment_confirmed without invoice.");
            }
            throw new \Magento\Framework\Exception\LocalizedException(__("Status update not allowed!"));
        }

        return [$history];
    }
}